//Box_Game1 (C) Freeware 1994 by Marty A. Lineberry
//Uses No Global variables
//Uses Line Draw and Put & Get IMAGE,Put a Pixel, Get Max X and Get May Y
//In VGA-HI Graphics Mode
//Screen Size horiz 640 vert 480   0,0 at upper left hand corner
//Pay particular attention at the box disappearing!
//This is caused by your program xor putimage getting in sync with the   
//display refresh rate. Try locking it into Vertical Sync.


//Compiled in small memory model
//& floating point emulation <Will cause compile errors if not set>
//instuction set 8088

#include <stdlib.h>
#include <conio.h>
#include <iostream.h>
#include <graphics.h>
#include <string.h>
#include <dos.h>
#include <stdio.h>
#include <bios.h>
#include <ctype.h>
#include <time.h>
#include "action.cpp"

//Needs to be changed for different graphic modes or
//use getspectratio() and calculate the correct sizes
#define SHIPWIDTH 25
#define SHIPHEIGHT 25
#define ENEMYSIZE 10


//Max_X and Max_Y are global variables defined in Action.CPP
//in InitGraph. Holds Maximum X and Y pixels for current
//screen mode.

//********************************************************************
//****************** Function prototypes. ****************************
//********************************************************************
void PerformGame(void);



//********************************************************************
//*********************** Main ***************************************
//********************************************************************
int main(void)
{
   // Initialize VGA graphics.
   InitGraphics(9);

   //Performs Game until ESC or Q is pressed
   PerformGame();

   //Reset's Graphics to original mode before InitGraphics()
   closegraph();

   //Pause's with output "Pause Press a Key"
   Pause(TRUE);
   return 1;
}




//********************************************************************
//******************* Performs Game **********************************
//********************************************************************
void PerformGame(void)
{

//Used to keep track of Enemy ship hits
int Score = 0;

//Used for Laser Fire Switch
int Fire_Sw = FALSE;
int Fire_Counter = 0;

//Used for counter to move and erase enemy
int counter = 0;

//Used for Enemy Direction and speed
int Enemy_Dir_X = ENEMYSIZE;
int Enemy_Dir_Y = ENEMYSIZE;

//Variables used for Your Ship's position and enemy
int Enemy_X = 25;
int Enemy_Y = 25;
int X = Max_X / 2; //or 320 in this graphics mode
int Y = Max_Y - (SHIPWIDTH);

//Used for Keystroke processing
int int_ch = 2;
char char_ch;


//Used for Put-Image and Get-Image
void *ship;
unsigned int size;

void *enemy_ship;
unsigned int size2;



//Draws you on screen before starting cause you're only
//drawn when you move & for Get-Image below
DrawBox(X,Y+(ENEMYSIZE / 2),(SHIPHEIGHT-3),SHIPHEIGHT/2,LIGHTGRAY,1);
DrawBox(X+(ENEMYSIZE / 2),Y,SHIPHEIGHT/2,SHIPHEIGHT/2,LIGHTGRAY,1);
DrawBox(Enemy_X, Enemy_Y, ENEMYSIZE, ENEMYSIZE, BLUE,1);


/* calculate the size of the image */
size = imagesize(X, Y, X + SHIPHEIGHT, Y + SHIPHEIGHT);
size2 = imagesize(Enemy_X, Enemy_Y, Enemy_X + ENEMYSIZE, Enemy_Y+ENEMYSIZE);


/* allocate memory to hold the image */
ship = malloc(size);
enemy_ship = malloc(size2);

/* grab the image */
getimage(X, Y, X+SHIPHEIGHT, Y+SHIPHEIGHT, ship);
getimage(Enemy_X, Enemy_Y, Enemy_X + ENEMYSIZE, Enemy_Y+ENEMYSIZE, enemy_ship);

//* clears graphics screen
cleardevice();

//*Use function we created to make backgroung a different color
DrawBox(0,0,Max_X,Max_Y,BROWN,3);


//Puts you on screen correctly before loops..You was drawn above^
putimage(X, Y, ship, XOR_PUT);
putimage(Enemy_X, Enemy_Y,enemy_ship,XOR_PUT);

//************************************************
//******** Program Loop **************************
//************************************************
while(TRUE)     //Starts Never Ending Loop
{

//Gets Keystrokes in buffer******************************************
    int_ch=Key_Press(&char_ch);

    //If a Key was pressed then process it's Variables
    if (int_ch)
	{
	//Exits loop Never Ending Loop
	if(int_ch == ESC) break;
	if((toupper(char_ch) == 'Q') OR (toupper(char_ch) == 'X')) break;

	//Pressing SpaceBar Fire's Laser
	if(((int_ch == SPACEBAR)OR(int_ch ==UP)) AND (Fire_Sw == FALSE))
		{
		Fire_Counter = 0;
		sound(100);
		Fire_Sw = TRUE;
		//test for a hit on enemy ship
		if((X + (SHIPHEIGHT /2)) <= ((Enemy_X + (ENEMYSIZE /2)) +  ((ENEMYSIZE /2)+1)))
			{
			if((X + (SHIPHEIGHT /2)) >= ((Enemy_X + (ENEMYSIZE /2)) - ((ENEMYSIZE /2)+1)))
				{
				Score++;

				putimage(Enemy_X, Enemy_Y,enemy_ship,XOR_PUT);
				Enemy_X = -10;
				Enemy_Y = -10;
				}
			}
		}

	/* erase old image */
	putimage(X, Y, ship, XOR_PUT);

	//Processes movement
	if((int_ch == LEFT) AND (Fire_Sw == FALSE))X = X - (SHIPWIDTH*1.5);
	if((int_ch == RIGHT) AND (Fire_Sw == FALSE))X = X + (SHIPWIDTH*1.5);

	//Keeps you from going off screen
	if(X >= (Max_X-SHIPWIDTH))X=(Max_X-SHIPWIDTH);
	if(X <= (0 + SHIPWIDTH))X=(0+SHIPWIDTH);


	/* plot new image */
	putimage(X, Y, ship, XOR_PUT);
	}

//Fire's Laser Action*************************************************
	if(Fire_Sw == TRUE)
	 {
	    Fire_Counter++;  //Adds to counter
	    if(Fire_Counter != 50) //Shows laser long enough too see it
		{
		//Puts Laser Fire on Screen
		setlinestyle(SOLID_LINE,0,NORM_WIDTH);
		setcolor(RED);  //laser in RED
		line(X + (SHIPWIDTH / 2), Y-1, X + (SHIPWIDTH / 2), 1); //Actual Laser
		}
	     else //Erases laser and reset's laser variable's
		{
		Fire_Counter = 0;
		Fire_Sw = FALSE;
		nosound();  //Turns off sound
	       //Erases Laser Fire
		setcolor(BROWN);
		setlinestyle(SOLID_LINE,0,THICK_WIDTH);
		line(X + (SHIPWIDTH / 2), Y-1, X + (SHIPWIDTH / 2), 1);
		//Resets color back to White just in-case
		setcolor(WHITE);
		}
	  }

//Counter to update Enemy Ship************************************
	counter++;

	//Updates Enemy Ship
	if(counter == 450)
		{
		counter = 0; //Reset's counter

		//Keeps Enemy ship running off screen by changing it's
		//direction and changes it speed randomly
		if(Enemy_X >= (Max_X - ENEMYSIZE)) Enemy_Dir_X = -((rand() % (5))+1);
		if(Enemy_X <= (0 + ENEMYSIZE)) Enemy_Dir_X = ((rand() % (5))+1);
		if(Enemy_Y >= (Max_Y / 2)) Enemy_Dir_Y = -((rand() % (5))+1);
		if(Enemy_Y <= (0 + ENEMYSIZE)) Enemy_Dir_Y = ((rand() % (5))+1);


		//erases enemy ship
		putimage(Enemy_X, Enemy_Y,enemy_ship,XOR_PUT);


		//draws enemy ship
		putimage(Enemy_X + Enemy_Dir_X, Enemy_Y + Enemy_Dir_Y,enemy_ship,XOR_PUT);

		//Updates the enemy's Ship Location Variables
		Enemy_Y = Enemy_Y + Enemy_Dir_Y;
		Enemy_X = Enemy_X + Enemy_Dir_X;



		}


}
/* clean up */
free(ship);
free(enemy_ship);
return;
}
